# Generated by Django 3.2.7 on 2024-03-26 22:49

from django.db import migrations, models

def update_placeholders(apps, schema_editor):
    new_fragments = {
    "ACCUEIL_UTILISATEUR_INFOS": {"display_name": "Infos page d'accueil utilisateur", "description": "Fragment permettant d'afficher des alertes dans la zone supérieure de la page d'accueil utilisateur (affichée lors de la connexion)."},
    "ACCUEIL_SITE": {"display_name": "Page d'accueil", "description": "Fragment permettant d'afficher du contenu en haut de la page d'accueil principale."},
    "PAGE_NOUVEAU_CONTRAT": {"display_name": "Page de création d'un nouveau contrat", "description": "Fragment permettant du contenu en haut de la page de création d'un nouveau contrat et du choix des produits."},
    "PAGE_SUCCES_CONTRAT": {"display_name": "Page de succès de création d'un contrat", "description": "Fragment permettant d'afficher un message après la signature d'un contrat."},
    "PAGE_ADHERER": {"display_name": "Page d'adhésion", "description": "Fragment permettant des informations sur la page d'adhésion."},
    "PAGE_MES_ADHESIONS": {"display_name": "Page de liste des adhésions", "description": "Fragment permettant d'afficher du contenu en haut de la page de liste des adhésions."},
    "PAGE_MES_CONTRATS": {"display_name": "Page de liste des contrats", "description": "Fragment permettant d'afficher du contenu en haut de la page de liste des contrats."},
    "PAGE_MES_FERMES": {"display_name": "Page de liste des fermes", "description": "Fragment permettant d'afficher du contenu en haut de la page de liste des fermes pour les paysans."},
    "DASHBOARD": {"display_name": "Tableau de bord gestionnaire", "description": "Fragment permettant d'afficher du contenu en haut de la page de tableau de bord du gestionnaire."}
    }

    GaiaHypertext = apps.get_model("gaia_utils", "GaiaHypertext")

    # Delete all fragments that are not in the new_fragments list
    for fragment in GaiaHypertext.objects.all():
        if not fragment.name in list(new_fragments.keys()):
            fragment.delete()

    # Set all existing fragments to active
    GaiaHypertext.objects.update(active=True)

    # Insert all fragments that are in the new_fragments list but not in the database
    for fragment_name in list(new_fragments.keys()):
        if not GaiaHypertext.objects.filter(name=fragment_name).exists():
            fragment = GaiaHypertext(name=fragment_name, display_name=new_fragments[fragment_name]["display_name"], description=new_fragments[fragment_name]["description"])
            fragment.save()

def remove_placeholders(apps, schema_editor):
    new_fragments = {
    "ACCUEIL_UTILISATEUR_INFOS": {"display_name": "Infos page d'accueil utilisateur", "description": "Fragment permettant d'afficher des alertes dans la zone supérieure de la page d'accueil utilisateur (affichée lors de la connexion)."},
    "ACCUEIL_SITE": {"display_name": "Page d'accueil", "description": "Fragment permettant d'afficher du contenu en haut de la page d'accueil principale."},
    "PAGE_NOUVEAU_CONTRAT": {"display_name": "Page de création d'un nouveau contrat", "description": "Fragment permettant du contenu en haut de la page de création d'un nouveau contrat et du choix des produits."},
    "PAGE_SUCCES_CONTRAT": {"display_name": "Page de succès de création d'un contrat", "description": "Fragment permettant d'afficher un message après la signature d'un contrat."},
    "PAGE_ADHERER": {"display_name": "Page d'adhésion", "description": "Fragment permettant des informations sur la page d'adhésion."},
    "PAGE_MES_ADHESIONS": {"display_name": "Page de liste des adhésions", "description": "Fragment permettant d'afficher du contenu en haut de la page de liste des adhésions."},
    "PAGE_MES_CONTRATS": {"display_name": "Page de liste des contrats", "description": "Fragment permettant d'afficher du contenu en haut de la page de liste des contrats."},
    "PAGE_MES_FERMES": {"display_name": "Page de liste des fermes", "description": "Fragment permettant d'afficher du contenu en haut de la page de liste des fermes pour les paysans."},
    "DASHBOARD": {"display_name": "Tableau de bord gestionnaire", "description": "Fragment permettant d'afficher du contenu en haut de la page de tableau de bord du gestionnaire."}
    }

    GaiaHypertext = apps.get_model("gaia_utils", "GaiaHypertext")
    GaiaHypertext.objects.filter(name__in=list(new_fragments.keys())).delete()


class Migration(migrations.Migration):

    dependencies = [
        ('gaia_utils', '0002_gaiahypertext'),
    ]

    operations = [
        migrations.AddField(
            model_name='gaiahypertext',
            name='active',
            field=models.BooleanField(default=False, verbose_name='Actif ?'),
        ),
        migrations.AlterField(
            model_name='gaiahypertext',
            name='content',
            field=models.TextField(blank=True, default="<div class='alert alert-info'>Votre message d'information ici</div>", verbose_name='Contenu'),
        ),
        migrations.RunPython(update_placeholders, remove_placeholders),
    ]
